LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY IOCHRDY IS
	PORT
	(
		LCD_ADD0	: IN	STD_LOGIC;
		B_IORN		: IN	STD_LOGIC;
		B_IOWN		: IN	STD_LOGIC;
		B_RESET		: IN	STD_LOGIC;
		B_CLK		: IN	STD_LOGIC;
		IOCHRDY		: OUT	STD_LOGIC);
END IOCHRDY;

ARCHITECTURE RTL OF IOCHRDY IS
	SIGNAL	Q	: STD_LOGIC;
	SIGNAL	IO		: STD_LOGIC;
begin
	IO <= (not B_IORN and LCD_ADD0) or (not B_IOWN and LCD_ADD0);
	process(IO,B_RESET,B_CLK)
	begin
		if (B_RESET='1') then
			Q <= '0';
			IOCHRDY <= '1';
		elsif (B_CLK'event and B_CLK='0') then
			if (IO = '1') then
				Q <= '1';
				IOCHRDY <= Q or not IO;
			else
				Q <= '0';
				IOCHRDY <= '1';
			end if;
		end if;
	end process;

end RTL;


