-- DATA LATCH MODULE	Produced by Simamu
--						Ver1.0 2000.9.7
-- DATA LATCH MODULE	Produced by MIRS0204
--						Ver2.0 2003.11.19
-- DATA LATCH MODULE	Produced by MIRS0204
--						Ver3.0 2004.1.21


LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY tld_latch IS
	PORT
	(
		TSIN		: IN	STD_LOGIC_VECTOR(5 downto 0);
		DCIN		: IN	STD_LOGIC_VECTOR(2 downto 0);
		LSIN		: IN	STD_LOGIC_VECTOR(1 downto 0);
		B_RESET		: IN	STD_LOGIC;
		B_CLK		: IN	STD_LOGIC;
		TLDOUT		: OUT 	STD_LOGIC_VECTOR(15 downto 0)
	);
END tld_latch;

ARCHITECTURE RTL OF tld_latch IS
	SIGNAL	TLDDUM	: STD_LOGIC_VECTOR(15 downto 0);
BEGIN
	PROCESS (B_CLK,B_RESET)
	BEGIN
		IF (B_RESET = '1')
		THEN	TLDDUM <= "0000000000000000";
		else
			IF (B_CLK'event AND B_CLK = '1')
			THEN
				TLDDUM(2 downto 0) <= DCIN;
				TLDDUM(4 downto 3) <= not LSIN;
				TLDDUM(13 downto 8) <= TSIN;
			END IF;
		END IF; 
	END PROCESS;
	TLDOUT(2 downto 0) <= TLDDUM(2 downto 0);
	TLDOUT(4 downto 3) <= TLDDUM(4 downto 3);
	TLDOUT(13 downto 8) <= TLDDUM(13 downto 8);
	TLDOUT(15) <= TLDDUM(15);
	TLDOUT(7 downto 5) <= "000";
	TLDOUT(14) <= '0';

END RTL;

